// @(#)$Id: CharSequence.spec,v 1.10 2005/02/18 03:52:36 davidcok Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package java.lang;

/**
 * JML's specification of {@link java.lang.CharSequence}.
 *
 * @version $Revision: 1.9 $
 * @author Gary T. Leavens
 * @author David R. Cok
 * @author Joseph R. Kiniry
 */
<<<<<<< CharSequence.spec
=======
public interface CharSequence {
    //@ public instance model char[] charArray;
    //@ public invariant charArray != null;
    //@ public invariant charArray.owner == this;

    /*@ public normal_behavior
        ensures \result == ( a == b || (a != null && b != null &&
                      a.length == b.length && 
                      (\forall int i; 0<=i && i<a.length; a[i] == b[i]))); 
        public static pure model boolean equal(char[] a, char[] b);
     */
    /*@ public normal_behavior
        requires a != null && b!= null && astart >= 0 && bstart >= 0 &&
                 length >= 0 &&
                 astart+length <= a.length && bstart + length <= b.length;
        ensures \result == ((a==b && astart == bstart) ||
                      (\forall int i; 0<=i && i<length; a[i+astart] == b[i+bstart])); 
        public static pure model boolean equal(char[] a, int astart, char[] b, int bstart, int length);
     */

    //@ axiom (\forall char[] a;; equal(a,a));
    //@ axiom (\forall char[] a,b;; equal(a,b) <==> equal(b,a));
    //@ axiom (\forall char[] a,b,c;; (equal(a,b) && equal(b,c))==>equal(a,c)); 
>>>>>>> 1.10

<<<<<<< CharSequence.spec
public interface CharSequence
{
  /*@ public normal_behavior
    @   assignable \nothing;
    @   ensures 0 <= \result;
    @*/
  /*@ pure @*/ int length();

  /*@ public normal_behavior
    @   requires 0 <= index && index < length();
    @   assignable \nothing;
    @   ensures (* \result is the character at the given index *);
    @ also
    @ public exceptional_behavior
    @   requires !(0 <= index && index < length());
    @   assignable \nothing;
    @   signals (IndexOutOfBoundsException);
    @*/
  //@ implies_that public normal_behavior
  //@   requires 0 <= index;
  //@   assignable \nothing;
  /*@ pure @*/ char charAt(int index) throws IndexOutOfBoundsException;

  /*@ public normal_behavior
    @   requires 0 <= start && start <= end && end <= length();
    @   assignable \nothing;
    @   ensures (* \result is the subsequence from start to end,
    @              not including the character at index end, if any *);
    @ also
    @ public exceptional_behavior
    @   requires start < 0 || end < 0 || end > length() || start > end;
    @   assignable \nothing;
    @   signals (IndexOutOfBoundsException);
    @*/
  /*@ pure @*/ CharSequence subSequence(int start, int end)
    throws IndexOutOfBoundsException;

  /*@ also
    @ public normal_behavior
    @   assignable \nothing;
    @   ensures \result != null
    @           && (* result is this sequence of characters *);
    @*/
  /*@ pure @*/ public String toString();

  /** According to the javadocs, the equals method should not be called. */
  //@ also
  //@   requires false;
  //@   assignable \nothing;
  /*@ pure @*/ public boolean equals(Object obj);

  /** According to the javadocs, the hashCode method should not be called. */
  //@ also
  //@   requires false;
  //@   assignable \nothing;
  /*@ pure @*/ public int hashCode();
=======
    //@ public normal_behavior
    //@      modifies objectState;
    //@      ensures \result >= 0;
    //@      ensures \result == charArray.length;
    int length();

    /*@   public normal_behavior
      @      requires 0 <= index && index < charArray.length;
      @      modifies objectState;
      @      ensures  \result == charArray[index];
      @  also
      @    public exceptional_behavior
      @      requires !(0 <= index && index < charArray.length);
      @      modifies objectState;
      @      signals (Exception e) e instanceof IndexOutOfBoundsException;
      @      signals (IndexOutOfBoundsException);
      @*/
    char charAt(int index) throws IndexOutOfBoundsException;

    /*@   public normal_behavior
      @      requires 0 <= start && start <= end && end <= charArray.length;
      @      modifies objectState;
      @      ensures \result.charArray.length == end-start;
      @      ensures equal(\result.charArray,0,charArray,start,end-start);
      @  also
      @    public exceptional_behavior
      @      requires start < 0 || end < start || end > charArray.length;
      @      modifies objectState;
      @      signals (Exception e) e instanceof IndexOutOfBoundsException;
      @      signals (IndexOutOfBoundsException);
      @*/
    CharSequence subSequence(int start, int end)
        throws IndexOutOfBoundsException;

    /*@ also
      @    public normal_behavior
      @      modifies objectState;
      @      ensures \result != null
      @           && equal(\result.charArray,charArray);
      @*/
    public String toString();

    /** According to the javadocs, the equals method should not be called. */
    //@ also
    //@      requires false;
    // @      modifies objectState;
    public boolean equals(Object obj);

    /** According to the javadocs, the hashCode method should not be called. */
    //@ also
    //@    requires false;
    //@      modifies objectState;
    public int hashCode();
>>>>>>> 1.10
}
